/*
    This file is part of random-image.

    random-image is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    random-image is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with random-image.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef HEADER_NETWORK
#define HEADER_NETWORK

#include "network.h"
#include <QString>
#include <QImage>
#include <QList>
#include <QThread>

#include <vector>
#include <string>

typedef struct Synapse
{
    unsigned int neurone_id;
    double       poids;
} Synapse;

typedef struct Neurone
{
    unsigned int      type;
    std::vector<Synapse> synapses;
    double        valeur;
    double seuil;

} Neurone;

class Network
{
    public:
        Network();
        ~Network();
        bool readFromFile(QString fileName);
        bool saveToFile(QString fileName);
        void mutate(qint16 mutations, qint16 modifications);
        void empty();
        unsigned int getComplexity() { return m_network.count() - 5; };
        QImage image(qreal width, qreal height, bool progress = false, QWidget* = NULL);

    private:
        QList<Neurone> m_network;
        bool isValidNet(QList<Neurone>*);
        void get_neurones_after(unsigned int, std::vector<unsigned int>*);

};

#endif
